package body test_queues is
    
    procedure copy ( from_Q : in queue; to_Q : inout queue ) is
        variable current_element : queue_ptr := from_Q.head;
        variable new_element : queue_ptr;
    begin
        while current_element /= null loop
            new_element := new queue_element'(
                the_test => current_element.the_test,
                next_element => null,
                prev_element => to_Q.tail );
            if to_Q.head = null then
                to_Q.head := new_element;
            end if;
            to_Q.tail := new_element;
            current_element := current_element.next_element;
        end loop;
    end procedure copy;
    
    
    impure function "=" ( L, R : in queue ) return boolean is
        variable current_L_element : queue_ptr := L.head;
        variable current_R_element : queue_ptr := R.head;
    begin
        while current_L_element /= null and current_R_element /= null loop
            if current_L_element.the_test /= current_R_element.the_test then
                return false;
            end if;
            current_L_element := current_L_element.next_element;
            current_R_element := current_R_element.next_element;
        end loop;
        return current_L_element = null and current_L_element = null;
    end function "=";
    
    
    impure function "/=" ( L, R : in queue ) return boolean is
    begin
        return not (L = R);
    end function "/=";


    impure function is_empty ( Q : queue ) return boolean is
    begin
        return Q.head = null;
    end function is_empty;
    
    
    procedure add ( Q : inout queue;  item : in test ) is
        variable new_element : queue_ptr := new queue_element'(
            the_test => item,
            next_element => null,
            prev_element => Q.tail );
    begin
        if Q.head = null then
            Q.head := new_element;
        end if;
        Q.tail := new_element;
    end procedure add;

    
    procedure remove ( Q : inout queue;  item : out test ) is
        variable head_element : queue_ptr;
    begin
        if not is_empty(Q) then
            head_element := Q.head;
            item := head_element.the_test;
            Q.head := head_element.next_element;
            if Q.head = null then
                Q.tail := null;
            end if;
            deallocate ( head_element );
        end if;
    end procedure remove;
    
    constant empty_queue : queue := queue'(null, null);
    
end package body test_queues;
